#ifndef __COMM_H
#define __COMM_H	1

#include "Notation.h"

#define	COM1	0x3F8
#define COM2	0x2F8
#define COM4	0x2E8

#define RBR		0	// Receive Buffer
#define THR		0	// Transmitter Buffer
#define DIVISOR_BAJO	0	// Latch divisor low
#define DIVISOR_ALTO	1       // Latch divisor high
#define	IER		1	// Interrupt Enable Register
#define IIR		2	// Interrupt ID Register
#define LCR		3	// Line Control Register
#define MCR		4	// Modem Control Register
#define LSR		5	// Line Status Register
#define MSR		6	// Modem Status Register


#define LATCH_DIVISOR	128
#define HABILITA_INT	8

#define	RX_ENABLE	1	//RxRDY Enable IRQ
#define TX_ENABLE	2	//Tx Biuffer Empty IRQ
#define MODEM_STATUS	8	//Modem handshake lines have changed

#define PIC_ICR		0x20	// PIC address
#define PIC_IMR		0x21	// PIC IRQ Mask Register
#define COM1_ISR	0x0C	// COM1 Vector Table Index
#define COM2_ISR	0x0B	// COM2 Vector Table index
#define COM4_ISR	0x08 + 9	// COM2 Vector Table index

//////////////// Functions to Export ////////////////////
void InitCommDriver (void);
void OpenComm (Word CommPort);
void CloseComm (void);
void AssignCommEventProc (EventProc Proc);
void WriteComm (Byte c);


#endif