/*/////////////////////////////////////////////////////////////////////////////

File Name : SLIP.h

Author : Rene Trenado

Location : Motorola Applications Lab, Baja California

Date Created : June 2000

Current Revision : 0.0

Notes : Definitions for the SLIP implementation

/////////////////////////////////////////////////////////////////////////////*/

#ifndef __SLIP_H
#define __SLIP_H	1

#include "Notation.h"

#ifndef	NULL
#define NULL	0
#endif

#define SLIP_MAX_SIZE 	88

#define SLIP_END	0xC0	//300 octal
#define SLIP_ESC	0xDB	//333 octal
#define ESC_END		0xDC	//334 octal
#define ESC_ESC 	0xDD	//335 octal

extern BYTE SLIPStatus;

extern const DWORD IP_ADDRESS;

void SLIPInit (void);
void ProcSLIPSend (BYTE *ptr, BYTE len);
void SLIPEntry (void);
void ProcSLIPReceive (BYTE c);

#define 	IsESC  	0x01		// Previous character received was a ESC char
#define 	ReSync 	0x04		// Re Synchronize to avoid inconplete IP frame reception
#define 	IsFrame	0x08		// A full packet
#define 	ByteRx 	0x10		// Receive a Byte


#endif
